---
- name: Deploy OpenStack machine
  hosts: localhost
  tasks:
    - name: Create OpenStack instance
      openstack.cloud.server:
        state: present
        auth:
          # Parameters available at ~okeanos dashboard > API access
          auth_url: https://accounts.okeanos.grnet.gr/identity/v2.0
          username: 8b18ad6e-34fb-42c4-911b-c0517fbfee57
          # The password is stored in an environment variable
          # and not here for security reasons.
          password: "{{ lookup('env', 'OS_PASSWORD') }}"
        # Replace the following with your preferences.
        # You may execute 'openstack server list' and then
        # 'openstack server show' to see examples of values.
        name: My machine
        flavor: C8R8192D60drbd
        image: ccfb0b8b-3f40-4f1d-b78c-b5c59e59e5ad
        key_name: pothitos
      register: new_instance
    - name: Add new instance to inventory
      ansible.builtin.add_host:
        name: "{{ new_instance.server.public_v4 }}"
        groups: new_instances
        # The username for the SSH connections
        ansible_user: ubuntu

- name: Interact with instance
  hosts: new_instances
  gather_facts: false
  tasks:
    - name: Wait for remote SSH service
      ansible.builtin.wait_for_connection:
    - name: Gathering facts
      ansible.builtin.setup:
    - name: Print distribution information
      ansible.builtin.debug:
        var: ansible_lsb
